(* call operation getting value from in-out parameter *)

(* Note: the original arith-package-3.wl tested the potentially out-of-range
    value assignment, which is not possibile to reproduce here,
    but the parameter passing is a valid test subject anyway *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`x <= 2147483647]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Subscript[P`x, 1] <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`x <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
