(* operation call passing potentially out-of-range value via out parameter to package variable protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        x -> smallInt
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> out[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {0 <= P`x <= 100},
                {}
            },
            {
                1,
                {0 <= P`x <= 100, -2147483648 <= Subscript[P`x, 1] <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[P`x, 1] <= 100]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[P`x, 1] <= 100]
                    },
                    failedT[P`x -> 0, Subscript[P`x, 1] -> -2]
                }
            },
        bar -> {}
        |>
    |>
]
