(* assignment to package variable protected by post-condition of preceding call with out parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> out[integer]] -> {post -> y < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x];
    x = x + 1 (* this is safe, becase of bar's post-conditions *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Subscript[P`x, 1] <= 2147483647, Subscript[P`x, 1] < 100},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Subscript[P`x, 1] <= 2147483647, Subscript[P`x, 1] < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Subscript[P`x, 1] <= 2147483647, Subscript[P`x, 1] < 100,
                    1 + Subscript[P`x, 1] == Subscript[P`x, 2]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers, Subscript[P`x, 2] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
