(* correct operation call passing value to in parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[42]
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True, bar -> False|>|>]

nChecks = reportNameChecks[sys];
Assert[nChecks === <|"P`" -> {{}, <|foo -> {}, bar -> {}|>}|>]

fChecks = reportFlowChecks[sys];
Assert[fChecks === <|"P`" -> <|foo -> {}, bar -> {}|>|>]

flow = reportControlFlow[sys, "P`", foo];
Assert[flow === {"start" \[DirectedEdge] "1. P`bar[...]", 
   "1. P`bar[...]" \[DirectedEdge] "finish"}]

calls = reportCallGraph[sys];
Assert[calls === {P`foo \[DirectedEdge] P`bar}]

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
            },
        bar -> {}
        |>
    |>
]
