(* incorrect operation call passing potentially out-of-range value to in parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x + 1]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    failedT[P`x -> 2147483647]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    failedT[P`x -> 2147483647]
                }
            },
        bar -> {}
        |>
    |>
]
