(* operation call with in parameter protected by condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    If[x < 100,
        bar[x + 1]
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Branch is reachable.",
                        possibleT[P`x < 100]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[P`x >= 100]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, P`x < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.", 
                        possibleT[P`x < 100]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.", 
                        possibleT[P`x >= 100]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
