(* operation call with in parameter protected by pre-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[] -> {pre -> x < 100},
        bar[y -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x + 1]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, P`x < 100},
                {
                    {
                        "Operation pre-conditions are reachable.",
                        possibleT[True]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, P`x < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    "start",
                    {
                        "Operation pre-conditions are reachable.", 
                        possibleT[True]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= 1 + P`x <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
