(* operation call with in parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        y -> smallInt
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[y + 1]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {0 <= P`y <= 100},
                {}
            },
            {
                1,
                {0 <= P`y <= 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    }
                }
            }
        },
        <|P`y -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
