(* incorrect operation call with potentially out-of-range value for in-out parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> inOut[smallInt]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= P`x <= 100]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, 0 <= Subscript[P`x, 1] <= 100},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[0 <= P`x <= 100]
                    },
                    failedT[P`x -> -2, Subscript[P`x, 1] -> 0]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
