(* incorrect call passing potentially out-of-range value to in-out parameter violating pre-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[y -> inOut[integer]] -> {pre -> y < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[x]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`x <= 2147483647]
                    },
                    {
                        "Operation call pre-conditions.",
                        alwaysT[P`x < 100]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Subscript[P`x, 1] <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= P`x <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Operation call pre-conditions.",
                        alwaysT[P`x < 100]
                    },
                    failedT[P`x -> 100, Subscript[P`x, 1] -> -184]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
