(* operation call with in-out parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        y -> smallInt
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[y] (* y + 1 would be a grammar error *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {0 <= P`y <= 100},
                {}
            },
            {
                1,
                {0 <= P`y <= 100},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`y <= 2147483647]
                    }
                }
            },
            {
                1,
                {0 <= P`y <= 100, -2147483648 <= Subscript[P`y, 1] <= 2147483647},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[P`y, 1] <= 100]
                    }
                }
            }
        },
        <|P`y -> Integers, Subscript[P`y, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= P`y <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[P`y, 1] <= 100]
                    },
                    failedT[P`y -> 0, Subscript[P`y, 1] -> -2]
                }
            },
        bar -> {}
        |>
    |>
]
