(* incorrect operation assigning explicitly out-of-range value to local variable *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
        x -> integer
    },
    x = 10000000000
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[x]},
                {}
            },
            {
                1,
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 10000000000},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 10000000000},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    failedT[x -> 0, Subscript[x, 1] -> 10000000000, initializedT[x] -> False, initializedT[Subscript[x, 1]] -> True]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
