(* correct operation assigning value to package variable *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = 42
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True|>|>]

nChecks = reportNameChecks[sys];
Assert[nChecks === <|"P`" -> {{}, <|foo -> {}|>}|>]

fChecks = reportFlowChecks[sys];
Assert[fChecks === <|"P`" -> <|foo -> {}|>|>]

flow = reportControlFlow[sys, "P`", foo];
Assert[flow === {"start" \[DirectedEdge] "1. P`x := ...", 
   "1. P`x := ..." \[DirectedEdge] "finish"}]

calls = reportCallGraph[sys];
Assert[calls === {}]

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, Subscript[P`x, 1] == 42},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
