(* incorrect operation assigning potentially out-of-range value to in-out parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = x + 1
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= x <= 2147483647},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + x <= 2147483647]
                    }
                }
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, 1 + x == Subscript[x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + x <= 2147483647]
                    },
                    failedT[x -> 2147483647, Subscript[x, 1] -> 0]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    failedT[x -> 2147483647, Subscript[x, 1] -> 2147483648]
                }
            }
        |>
    |>
]
