(* assignment to in-out parameter protected by condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    If[x < 100,
        x = x + 1
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= x <= 2147483647},
                {
                    {
                        "Branch is reachable.",
                        possibleT[x < 100]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[x >= 100]
                    }
                }
            },
            {
                2,
                {-2147483648 <= x <= 2147483647, x < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + x <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= x <= 2147483647, 1 + x == Subscript[x, 1], x < 100},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers, Subscript[x, 2] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.", 
                        possibleT[x < 100]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.", 
                        possibleT[x >= 100]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + x <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
