(* assignment to in-out parameter protected by pre-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        y -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[x -> inOut[integer]] -> {pre -> y < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = y + 1
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647, -2147483648 <= P`y <= 2147483647, P`y < 100},
                {
                    {
                        "Operation pre-conditions are reachable.",
                        possibleT[True]
                    }
                }
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, -2147483648 <= P`y <= 2147483647, P`y < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    }
                }
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, -2147483648 <= P`y <= 2147483647, P`y < 100, 1 + P`y == Subscript[x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|x -> Integers, P`y -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    "start",
                    {
                        "Operation pre-conditions are reachable.", 
                        possibleT[True]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
