(* incorrect assignment of explicitly out-of-range value to in-out parameter violating post-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[x -> inOut[integer]] -> {post -> x < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = 150
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, Subscript[x, 1] == 150},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {-2147483648 <= x <= 2147483647, Subscript[x, 1] == 150},
                {
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[x, 1] < 100]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[x, 1] < 100]
                    },
                    failedT[x -> -2147483648, Subscript[x, 1] -> 150]
                }
            }
        |>
    |>
]
