(* incorrect assignment of potentially out-of-range value to in-out parameter violating post-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[y -> inOut[integer]] -> {post -> y < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    y = x
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= y <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= y <= 2147483647, P`x == Subscript[y, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[y, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= y <= 2147483647, P`x == Subscript[y, 1]},
                {
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[y, 1] < 100]
                    }
                }
            }
        },
        <|P`x -> Integers, y -> Integers, Subscript[y, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[y, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[y, 1] < 100]
                    },
                    failedT[P`x -> 100, y -> -2147483648, Subscript[y, 1] -> 100]
                }
            }
        |>
    |>
]
