(* assignment to in-out variable protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        y -> smallInt
    }
];
declareOperations[sys, "P`",
    {
        foo[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = y + 1
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647, 0 <= P`y <= 100},
                {}
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, 0 <= P`y <= 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    }
                }
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, 0 <= P`y <= 100, 1 + P`y == Subscript[x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|x -> Integers, P`y -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
