(* assignment to out parameter protected by condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        y -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[x -> out[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    If[y < 100,
        x = y + 1
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`y <= 2147483647, !initializedT[x]},
                {}
            },
            {
                1,
                {-2147483648 <= P`y <= 2147483647, !initializedT[x]},
                {
                    {
                        "Branch is reachable.",
                        possibleT[P`y < 100]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[P`y >= 100]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`y <= 2147483647, !initializedT[x], P`y < 100},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`y <= 2147483647, !initializedT[x], initializedT[Subscript[x, 1]], 1 + P`y == Subscript[x, 1], P`y < 100},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {
                    -2147483648 <= P`y <= 2147483647, !initializedT[x], 1 + P`y == Subscript[x, 1], initializedT[Subscript[x, 1]],
                    P`y < 100 \[Implies] Subscript[x, 2] == Subscript[x, 1],
                    P`y < 100 \[Implies] initializedT[Subscript[x, 2]] == initializedT[Subscript[x, 1]],
                    P`y >= 100 \[Implies] Subscript[x, 2] == x,
                    P`y >= 100 \[Implies] initializedT[Subscript[x, 2]] == initializedT[x]
                },
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 2]]]
                    }
                }
            }
        },
        <|x -> Integers, P`y -> Integers, Subscript[x, 1] -> Integers, Subscript[x, 2] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.", 
                        possibleT[P`y < 100]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.", 
                        possibleT[P`y >= 100]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Subexpression should fit the base type.", 
                        alwaysT[-2147483648 <= 1 + P`y <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 2]]]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
