(* array access to explicitly incorrect index *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myArrayType -> array[integer, 10]
    }
];
defineDataObjects[sys, "P`",
    {
        a -> myArrayType
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    a[[20]] = 42
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= Inactive[Part][P`a, 20] <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= Inactive[Part][P`a, 20] <= 2147483647},
                {
                    {
                        "Array index should be within bounds.",
                        alwaysT[False]
                    }
                }
            },
            {
                1,
                {-2147483648 <= Inactive[Part][P`a, 20] <= 2147483647, Inactive[Part][Subscript[P`a, 1], 20] == 42},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 20] <= 2147483647]
                    }
                }
            }
        },
        <|Inactive[Part][Subscript[P`a, 1], 20] -> Integers, Inactive[Part][P`a, 20] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Array index should be within bounds.",
                        alwaysT[False]
                    },
                    failedT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 20] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
