(* array access to potentially incorrect index *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myArrayType -> array[integer, 10]
    }
];
defineDataObjects[sys, "P`",
    {
        a -> myArrayType,
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    a[[x]] = 42
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, P`x] <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, P`x] <= 2147483647},
                {
                    {
                        "Array index should be within bounds.",
                        alwaysT[0 <= P`x <= 9]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, P`x] <= 2147483647,
                    Inactive[Part][Subscript[P`a, 1], P`x] == 42},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], P`x] <= 2147483647]
                    }
                }
            }
        },
        <|Inactive[Part][Subscript[P`a, 1], P`x] -> Integers, P`x -> Integers, Inactive[Part][P`a, P`x] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Array index should be within bounds.",
                        alwaysT[0 <= P`x <= 9]
                    },
                    failedT[P`x -> -2, Inactive[Part][P`a, P`x] -> 0, Inactive[Part][Subscript[P`a, 1], P`x] -> 0]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], P`x] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
