(* array write and read from the same index *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myArrayType -> array[integer, 10]
    }
];
defineDataObjects[sys, "P`",
    {
        a -> myArrayType,
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    a[[1]] = 42;
    x = a[[1]]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    Inactive[Part][Subscript[P`a, 1], 1] == 42},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    Inactive[Part][Subscript[P`a, 1], 1] == 42, Subscript[P`x, 1] == Inactive[Part][Subscript[P`a, 1], 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Inactive[Part][Subscript[P`a, 1], 1] -> Integers, Inactive[Part][P`a, 1] -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
