(* array write (by means of out parameter) and read (by means of in parameter) from a different index *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myArrayType -> array[integer, 10]
    }
];
defineDataObjects[sys, "P`",
    {
        a -> myArrayType
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> out[integer]],
        baz[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[a[[1]]]; (* write to a[[1]] *)
    baz[a[[2]]]; (* read from a[[2]] *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    -2147483648 <= Inactive[Part][P`a, 2] <= 2147483647
                },
                {}
            },
            {
                1,
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    -2147483648 <= Inactive[Part][P`a, 2] <= 2147483647,
                    -2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647,
                    Inactive[Part][P`a, 2] == Inactive[Part][Subscript[P`a, 1], 2]
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    }
                }
            },
            {
                2,
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    -2147483648 <= Inactive[Part][P`a, 2] <= 2147483647,
                    -2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647,
                    Inactive[Part][P`a, 2] == Inactive[Part][Subscript[P`a, 1], 2]
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 2] <= 2147483647]
                    }
                }
            }
        },
        <|
            Inactive[Part][Subscript[P`a, 1], 1] -> Integers,
            Inactive[Part][P`a, 1] -> Integers,
            Inactive[Part][Subscript[P`a, 1], 2] -> Integers,
            Inactive[Part][P`a, 2] -> Integers
        |>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 2] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {},
        baz -> {}
        |>
    |>
]
