(* array update by means of in-out parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myArrayType -> array[integer, 10]
    }
];
defineDataObjects[sys, "P`",
    {
        a -> myArrayType
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[a[[1]]]; (* write and read *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647
                },
                {}
            },
            {
                1,
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][P`a, 1] <= 2147483647]
                    }
                }
            },
            {
                1,
                {
                    -2147483648 <= Inactive[Part][P`a, 1] <= 2147483647,
                    -2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    }
                }
            }
        },
        <|
            Inactive[Part][Subscript[P`a, 1], 1] -> Integers,
            Inactive[Part][P`a, 1] -> Integers
        |>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][P`a, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Inactive[Part][Subscript[P`a, 1], 1] <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
