(* if with else *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer,
        y -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    If[x > 0,
        x = 1,
        x = -1
    ];
    y = x
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647},
                {
                    {
                        "Branch is reachable.",
                        possibleT[P`x > 0]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[P`x <= 0]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647, Subscript[P`x, 1] == 1, P`x > 0},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                3,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647, Subscript[P`x, 2] == -1, P`x <= 0},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    }
                }
            },
            {
                4,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647, Subscript[P`x, 1] == 1, Subscript[P`x, 2] == -1,
                    P`x > 0 \[Implies] Subscript[P`x, 3] == Subscript[P`x, 1],
                    P`x <= 0 \[Implies] Subscript[P`x, 3] == Subscript[P`x, 2],
                    Subscript[P`x, 3] == Subscript[P`y, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`y, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, P`y -> Integers,
            Subscript[P`x, 1] -> Integers, Subscript[P`x, 2] -> Integers, Subscript[P`x, 3] -> Integers, Subscript[P`y, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`x > 0]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.",
                        possibleT[P`x <= 0]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    3,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    4,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`y, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
