(* switch statement with all enums listed in separate branches *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys,"P`",
    {
        colors -> enum[red, green, blue]
    }
];
defineDataObjects[sys, "P`",
    {
        x -> colors
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    Switch[x,
        red,
            Null,
        green,
            Null,
        blue,
            Null
    ]
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True|>|>]

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                1,
                {},
                {
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`red]
                    },
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`green]
                    },
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`blue]
                    }
                }
            }
        },
        <|P`x -> P`colors|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`red]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`green]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`x == P`blue]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
