(* while loop *)

(* Note: loop invariants are not maintained if not expressed explicitly. *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    While[x > 0,
        x = x - 1
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647},
                {
                    {
                        "Branch is reachable.",
                        possibleT[P`x > 0]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, P`x > 0, Subscript[P`x, 1] > 0},
                {
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= -1 + Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, Subscript[P`x, 1] == 1 + Subscript[P`x, 2], P`x > 0, Subscript[P`x, 1] > 0},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers, Subscript[P`x, 2] -> Integers, Subscript[P`x, 3] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`x > 0]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= -1 + Subscript[P`x, 1] <= 2147483647]
                    },
                    failedT[P`x -> 1, Subscript[P`x, 1] -> 2147483649, Subscript[P`x, 2] -> 0, Subscript[P`x, 3] -> 0]
                },
                {
                    2,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 2] <= 2147483647]
                    },
                    failedT[P`x -> 1, Subscript[P`x, 1] -> 2147483649, Subscript[P`x, 2] -> 2147483648, Subscript[P`x, 3] -> 0]
                }
            }
        |>
    |>
]
