(* two functions calling one another *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[]
];
defineOperation[sys, "P`", bar,
    {
    },
    Null
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True, bar -> True|>|>]

nChecks = reportNameChecks[sys];
Assert[nChecks === <|"P`" -> {{}, <|foo -> {}, bar -> {}|>}|>]

fChecks = reportFlowChecks[sys];
Assert[fChecks === <|"P`" -> <|foo -> {}, bar -> {}|>|>]

calls = reportCallGraph[sys];
Assert[calls === {P`foo \[DirectedEdge] P`bar}]

proofSt = reportProofStatements[sys, "P`", foo]
Assert[proofSt === {{}, <||>}]
proofSt = reportProofStatements[sys, "P`", bar]
Assert[proofSt === {{}, <||>}]

proofs = reportProofs[sys];
Assert[proofs === <|"P`" -> <|foo -> {}, bar -> {}|>|>]
