(* three functions calling each other with cycle *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[],
        baz[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[]
];
defineOperation[sys, "P`", bar,
    {
    },
    baz[]
];
defineOperation[sys, "P`", baz,
    {
    },
    foo[]
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True, bar -> True, baz -> True|>|>]

nChecks = reportNameChecks[sys];
Assert[nChecks === <|"P`" -> {{}, <|foo -> {}, bar -> {}, baz -> {}|>}|>]

fChecks = reportFlowChecks[sys];
Assert[fChecks === <|"P`" -> <|foo -> {}, bar -> {}, baz -> {}|>|>]

calls = reportCallGraph[sys];
Assert[calls === {P`foo \[DirectedEdge] P`bar, P`bar \[DirectedEdge] P`baz, P`baz \[DirectedEdge] P`foo}]

cycles = reportCallCycles[sys];
Assert[cycles ===
    {{P`foo \[DirectedEdge] P`bar, P`bar \[DirectedEdge] P`baz, P`baz \[DirectedEdge] P`foo},
        {{P`foo \[DirectedEdge] P`bar, P`bar \[DirectedEdge] P`baz, P`baz \[DirectedEdge] P`foo}}
    }
]

proofSt = reportProofStatements[sys, "P`", foo]
Assert[proofSt === {{}, <||>}]
proofSt = reportProofStatements[sys, "P`", bar]
Assert[proofSt === {{}, <||>}]
proofSt = reportProofStatements[sys, "P`", baz]
Assert[proofSt === {{}, <||>}]

proofs = reportProofs[sys];
Assert[proofs === <|"P`" -> <|foo -> {}, bar -> {}, baz -> {}|>|>]
