(* divide by potentially zero value *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer,
        y -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = x / y
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647},
                {
                    {
                        "Division by zero.",
                        neverT[P`y == 0]
                    },
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= IntegerPart[P`x / P`y] <= 2147483647]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`y <= 2147483647, IntegerPart[P`x / P`y] == Subscript[P`x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, P`y -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Division by zero.",
                        neverT[P`y == 0]
                    },
                    failedT[P`x -> 0, P`y -> 0, Subscript[P`x, 1] -> 0]
                },
                {
                    1,
                    {
                        "Subexpression should fit the base type.",
                        alwaysT[-2147483648 <= IntegerPart[P`x / P`y] <= 2147483647]
                    },
                    failedT[P`x -> -2147483648, P`y -> -1, Subscript[P`x, 1] -> 0]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    failedT[P`x -> -2147483648, P`y -> -1, Subscript[P`x, 1] -> 2147483648]
                }
            }
        |>
    |>
]
