(* uninitialized local variable used (read) in assignment expression *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
        i -> integer
    },
    x = i
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, !initializedT[i]},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, !initializedT[i]},
                {
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    }
                }
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, !initializedT[i], i == Subscript[P`x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {-2147483648 <= P`x <= 2147483647, !initializedT[i], i == Subscript[P`x, 1]},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    }
                }
            }
        },
        <|i -> Integers, P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    },
                    failedT[i -> -5, P`x -> -2147483648, Subscript[P`x, 1] -> -18, initializedT[i] -> False]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    failedT[i -> -2147483650, P`x -> 0, Subscript[P`x, 1] -> -2147483650, initializedT[i] -> False]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    },
                    impossibleT[]
                }
            }
        |>
    |>
]
