(* uninitialized local variable used (read) in control expression *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
        i -> integer
    },
    If[i > 0,
        Null
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[i]},
                {}
            },
            {
                1,
                {!initializedT[i]},
                {
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    },
                    {
                        "Branch is reachable.",
                        possibleT[i > 0]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[i <= 0]
                    }
                }
            },
            {
                "finish",
                {!initializedT[i]},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    }
                }
            }
        },
        <|i -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    },
                    failedT[i -> -24, initializedT[i] -> False]
                },
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[i > 0]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.",
                        possibleT[i <= 0]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    },
                    impossibleT[]
                }
            }
        |>
    |>
]
