(* uninitialized local variable used (read) as in parameter in operation call *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
        i -> integer
    },
    bar[i]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[i]},
                {}
            },
            {
                1,
                {!initializedT[i]},
                {
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    },
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= i <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {!initializedT[i]},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    }
                }
            }
        },
        <|i -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Variable should be initialized before use.",
                        alwaysT[initializedT[i]]
                    },
                    failedT[i -> -24, initializedT[i] -> False]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= i <= 2147483647]
                    },
                    failedT[i -> -2147483650, initializedT[i] -> False]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[i]]
                    },
                    impossibleT[]
                }
            },
        bar -> {}
        |>
    |>
]
