(* local variable initialized by out parameter in operation call *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> out[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
        i -> integer
    },
    bar[i]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[i]},
                {}
            },
            {
                1,
                {!initializedT[i], -2147483648 <= Subscript[i, 1] <= 2147483647, initializedT[Subscript[i, 1]]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[i, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {!initializedT[i], -2147483648 <= Subscript[i, 1] <= 2147483647, initializedT[Subscript[i, 1]]},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[i, 1]]]
                    }
                }
            }
        },
        <|i -> Integers, Subscript[i, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[i, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[i, 1]]]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
