(* logic reachability of condition with two variables *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        a -> boolean,
        b -> boolean
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    If[a && b,
        Null
    ]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                1,
                {
                },
                {
                    {
                        "Logic value should be reachable.",
                        possibleT[P`a]
                    },
                    {
                        "Logic value should be reachable.",
                        possibleT[!P`a]
                    },
                    {
                        "Logic value should be reachable.",
                        possibleT[P`b]
                    },
                    {
                        "Logic value should be reachable.",
                        possibleT[!P`b]
                    },
                    {
                        "Branch is reachable.",
                        possibleT[P`a && P`b]
                    },
                    {
                        "Alternative is reachable.",
                        possibleT[!(P`a && P`b)]
                    }
                }
            }
        },
        <|
            P`a -> Booleans, P`b -> Booleans
        |>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Logic value should be reachable.",
                        possibleT[P`a]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Logic value should be reachable.",
                        possibleT[!P`a]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Logic value should be reachable.",
                        possibleT[P`b]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Logic value should be reachable.",
                        possibleT[!P`b]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Branch is reachable.",
                        possibleT[P`a && P`b]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Alternative is reachable.",
                        possibleT[!(P`a && P`b)]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
