(* structure write and read from the same field *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myStructType -> structure[a -> integer, b -> integer]
    }
];
defineDataObjects[sys, "P`",
    {
        s -> myStructType,
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    s.a = 42;
    x = s.a
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`s.a <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`s.a <= 2147483647,
                    Subscript[P`s, 1].a == 42},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    }
                }
            },
            {
                2,
                {-2147483648 <= P`x <= 2147483647, -2147483648 <= P`s.a <= 2147483647,
                    Subscript[P`s, 1].a == 42, Subscript[P`s, 1].a == Subscript[P`x, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            }
        },
        <|P`x -> Integers, P`s.a -> Integers, Subscript[P`s, 1].a -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
