(* structure write (by means of out parameter) and read (by means of in parameter) from a different field *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myStructType -> structure[a -> integer, b -> integer]
    }
];
defineDataObjects[sys, "P`",
    {
        s -> myStructType
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> out[integer]],
        baz[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[s.a]; (* write to s.a *)
    baz[s.b]; (* read from s.b *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {
                    -2147483648 <= P`s.a <= 2147483647,
                    -2147483648 <= P`s.b <= 2147483647
                },
                {}
            },
            {
                1,
                {
                    -2147483648 <= P`s.a <= 2147483647,
                    -2147483648 <= P`s.b <= 2147483647,
                    -2147483648 <= Subscript[P`s, 1].a <= 2147483647,
                    P`s.b == Subscript[P`s, 1].b
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    }
                }
            },
            {
                2,
                {
                    -2147483648 <= P`s.a <= 2147483647,
                    -2147483648 <= P`s.b <= 2147483647,
                    -2147483648 <= Subscript[P`s, 1].a <= 2147483647,
                    P`s.b == Subscript[P`s, 1].b
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].b <= 2147483647]
                    }
                }
            }
        },
        <|
            P`s.a -> Integers,
            Subscript[P`s, 1].a -> Integers,
            Subscript[P`s, 1].b -> Integers,
            P`s.b -> Integers
        |>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    },
                    provenT[]
                },
                {
                    2,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].b <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {},
        baz -> {}
        |>
    |>
]
