(* structure update by means of in-out parameter *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        myStructType -> structure[a -> integer, b -> integer]
    }
];
defineDataObjects[sys, "P`",
    {
        s -> myStructType
    }
];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> inOut[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[s.a]; (* write and read *)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {
                    -2147483648 <= P`s.a <= 2147483647
                },
                {}
            },
            {
                1,
                {
                    -2147483648 <= P`s.a <= 2147483647
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`s.a <= 2147483647]
                    }
                }
            },
            {
                1,
                {
                    -2147483648 <= P`s.a <= 2147483647,
                    -2147483648 <= Subscript[P`s, 1].a <= 2147483647
                },
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    }
                }
            }
        },
        <|
            P`s.a -> Integers,
            Subscript[P`s, 1].a -> Integers
        |>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= P`s.a <= 2147483647]
                    },
                    provenT[]
                },
                {
                    1,
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`s, 1].a <= 2147483647]
                    },
                    provenT[]
                }
            },
        bar -> {}
        |>
    |>
]
